clear all
close all
clc

%% Ucitavanje mreznih elemenata

load('Test feeder.mat') ;
j = sqrt(-1) ;
Zl = R + j*X ;
S = -Pl-j*Ql ;

%% Inicijalizacija

V = ones(1,Number_of_Nodes) ;
V_old = 2*V ;
V_new = V ;
Eps = 1e-3 ;
I = zeros(1,Number_of_Nodes) ; 
Jl = zeros(1,Number_of_Branches) ; 
iter = 0 ;

while max(abs(V_old-V_new)) > Eps
    
    iter = iter + 1 ;
    V_old = abs(V) ; 
    
    for i = 1 : Number_of_Nodes
        
        I(i) = conj(S(i)/V(i)) ;
        
    end
    
    for i = Number_of_Branches : -1 : 1
        
        Jl(i) = -I(Rec_Bus(i)) ;
        
        if (any(A(Rec_Bus(i),:)) ~= 0)
            
            for k = i + 1 : Number_of_Branches
                
                if Send_Bus(k) == Rec_Bus(i)
                    
                    Jl(i) = Jl(i) + Jl(k) ;
                    
                end
                
            end
            
        end
        
    end
    
    for i = 1 : Number_of_Branches
        
       V(Rec_Bus(i)) = V(Send_Bus(i)) - Zl(i)*Jl(i) ;  
        
    end
    
    V_new = abs(V) ; 
    
end

plot(abs(V))